@ECHO off
@ECHO ============================================
@ECHO.
@ECHO  PBR texture batching script for rFactor 2
@ECHO  Last update: 2022-04-01
@ECHO.
@ECHO  This script requires ImageMagick installed.
@ECHO  Put only texture files you want to process
@ECHO  in the same folder of this script.
@ECHO.
@ECHO ============================================
@ECHO  ImageMagick supports many image format,
@ECHO  such as png, dds, jpg, tga (words only).
@ECHO.
SET /p Format="Enter valid file extension: "
@ECHO.
@ECHO  %Format% file format is now set for processing.
@ECHO.
@ECHO  Please select an option below to continue:
@ECHO --------------------------------------------
@ECHO  Press 1 to generate Albedo Map
@ECHO  Press 2 to generate Albedo Map with Alpha
@ECHO  Press 3 to generate Metal and Rough Map
@ECHO  Press 4 to generate Rough Map only
@ECHO  Press 5 to generate Metal Map only
@ECHO.
@ECHO  Press Q to Quit
@ECHO --------------------------------------------
@CHOICE /C 12345Q
GOTO option-%errorlevel%

:option-1 albedomap
@ECHO on
FOR %%a IN (*.%Format%) DO magick convert "%%~a" -channel RGB ( -clone 0 -set colorspace Gray -separate -average -negate ) ( -clone 0 ) -compose multiply -composite "%%~dpna_Alb.tga"
@ECHO off
GOTO END

:option-2 albedomapalpha
@ECHO on
FOR %%a IN (*.%Format%) DO magick convert "%%~a" -channel RGB ( -clone 0 -set colorspace Gray -separate -average -negate ) ( -clone 0 ) -compose multiply -composite "%%~dpna_Alba.tga"
@ECHO off
GOTO END

:option-3 metalroughmap
@ECHO on
FOR %%a IN (*.%Format%) DO magick convert "%%~a" -channel RGB -set colorspace Gray -separate -average -negate -fill black -colorize 0,0,100%% "%%~dpna_Mr.tga"
@ECHO off
GOTO END

:option-4 roughmap
@ECHO on
FOR %%a IN (*.%Format%) DO magick convert "%%~a" -channel RGB -set colorspace Gray -separate -average -negate -fill black -colorize 100%%,0,100%% "%%~dpna_Mr.tga"
@ECHO off
GOTO END

:option-5 metalmap
@ECHO on
FOR %%a IN (*.%Format%) DO magick convert "%%~a" -channel RGB -set colorspace Gray -separate -average -negate -fill black -colorize 0,0,100%% -fill white -colorize 0,100%%,0 "%%~dpna_Mr.tga"
@ECHO off
GOTO END

:END
@ECHO.
@ECHO --------------------------------------------
@ECHO  Processing Completed, press any key to exit
@ECHO --------------------------------------------
@ECHO.
PAUSE


:option-Q exit
exit